w=0.1:0.1:10000;
clc;

Kl=1;
Tl=2.2*10^-4;
Kx=5.8*10^-4;
Ex=0.2;
% 3  Tx
% M1-M18 Tx: 7 * 10^-4, 1.1*10^-3, 1.2*10^-3
% M19-27 Tx: 0.69 * 10^-3, 1.15 * 10^-3, 1.25 * 10^-3
Tx=1.25*10^-3;
Kgp1=137;
K=2.6*10^5;
% Ip=0.1;
% Il=0.002;

W7=tf(Kl,[Tl 1]);
W8=tf(Kx,[Tx^2 2*Ex*Tx 1]);
W10=tf(Kgp1,[1 0]);
W15=tf(K,[1 0]);
W33=7.9*10^(-4)
W34=tf(1,[1 0]);
% W35=Ip;
% W37=Il;

W_78=Series(W7,W8);
W_710=Series(W_78,W10);
W_1=FeedBack(W_710,1);

W341=1/W34;
W33_34=Series(W33,W341);
W15_34=Series(W34,W15);
W_2=FeedBack(W15_34,W33_34);

% W_3=W35*W37;

% W2_6=Series(W_2,W34);
W_2_=FeedBack(W_2,1);

W_1_2_=Series(W_1,W_2_);
W_1_=FeedBack(W_1_2_,W341);

% Wnr=Series(W_1_, W_3);
Wnr=FeedBack(W_1_2_,1);

zpk(Wnr);

figure(1);
bode(Wnr);
grid;
hold;

figure(2); 
  step(feedback(Wnr, 1), 8);
grid;

figure(3);
[u, t]=gensig('sin', 2*pi/1200, 3*2*pi/1200, 0.00001);
sys=tf([1], [0 1]);
H=[sys; FeedBack(Wnr, 1)];
lsim(H, u, t);
hold on;

Tg=6.7*10^-3;
Kv=6000;

wg=(2*pi)/Tg;
lgwg = log10(wg);
wn=0.16*wg;
lgwn=log10(wn);
wv=6.5*wg;
lgwv=log10(wv);

lgW_1=0.5;
lgW_2=1.4;
lgW_31=5;
lgW_3=5.2;
lgW_4=5.4;
lgW_5=5.6;
lgW_6=5.8;

w_1=10^lgW_1;
w_2=10^lgW_2;
w_31=10^lgW_31;
w_3=10^lgW_3;
w_4=10^lgW_4;
w_5=10^lgW_5;
w_6=10^lgW_6;


Wg=zpk([-wn],[-w_1 -w_2 -w_31 -w_3 -w_4 -w_5 -w_6], Kv*w_1*w_2*w_31*w_3*w_4*w_5*w_6/wn);

Wpku=Wg/Wnr;
tf(Wpku)
zpk(Wpku);

figure(4);
bode(Wnr,Wg,Wpku);
grid;
hold on;

figure(5);
step(feedback(Wpku*Wnr, 1), 0:1e-4:7e-3);
grid;
hold on;

figure(6);
[u, t]=gensig('sin', 2*pi/1200, 3*2*pi/1200, 0.00001);
sys=tf([1], [0 1]);
H=[sys; feedback(series(Wpku,Wnr),1)];
lsim(H, u, t);
hold on;
